﻿init python:
    import pygame
    import random
    import time
    random.seed(time.clock())
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result
    class enemy:
        def __init__(self,image):
            self.image = image
            self.health = 2
            self.x = random.choice([-270, 270])
            self.y = 0
            self.handler = None
            self.alive = True
        def move(self, target):
            distance = random.randint(6,12)
            if self.x > target.x:
                self.x -= distance
            else:
                self.x += distance
        def damage(self):
            self.health -= 1
            if self.health < 1:
                self.alive = False
                self.handler.score += 1

    class enemy_handler:
        def __init__(self):
            self.enemies = []
            self.time = 0
            self.score = 0
            
        def tick(self):
            for i in self.enemies:
                if not i.alive:
                    i.image = random.choice(["slime", "cat", "bat", "scorpion"])
                    i.health = 2
                    i.x = random.choice([-270, 270])
                    i.alive = True
                    if i.image == "bat":
                        i.y = random.randint(-60,-25)
                    else:
                        i.y = 0
                    break
            else:
                if len(self.enemies) < 8:
                    e = enemy(random.choice(["slime", "cat", "bat", "scorpion"]))
                    e.handler = self
                    if e.image == "bat":
                        e.y = random.randint(-60,-25)
                    self.enemies.append(e)

        def move(self, target):
            self.time += .1
            if len(self.enemies):
                tries = 0
                e = None
                while tries < 10:
                    e = random.choice(self.enemies)
                    if e.alive:
                        e.move(target)
                        break
                    tries += 1
    class KeyRoll(renpy.Displayable):
        def __init__(self,image):
            super(renpy.Displayable,self).__init__()
            self.start_image = image
            self.go_left = 0
            self.go_right = 0
            self.go_up = 0
            self.go_down = 0
            self.x = 0
            self.y = 0
            self.speed = 3.0
            self.facing = 1
            self.frame = 4
            self.max_frames = 3
            self.y_velocity = 0
        def animate(self):
            if self.frame == 5:
                self.frame = 4
                renpy.redraw(self, 0)
            else:
                self.frame += 1
                if self.frame > self.max_frames:
                    self.frame = 0


        def attack(self, enemies):
            self.frame = 5
            renpy.redraw(self, 0)
            hit = False
            for i in enemies:
                if i.alive:
                    if distance(self.x, i.x - (self.facing*14)) < 16:
                        if distance(self.y, i.y) < 24:
                            i.damage()
                            hit = True
            if hit:
                renpy.play("holding/punch.ogg", "sound")
            else:
                renpy.play("holding/miss.ogg", "sound")
        def jump(self):
            if self.y == 0:
                self.y_velocity = -10
        def idle(self):
            self.frame = 4
            renpy.redraw(self, 0)
        def render(self,width,height,st,at):
            self.x += (self.go_left+self.go_right)*self.speed
            # self.y += (self.go_up+self.go_down)*self.speed
            self.y += self.y_velocity
            if self.y < 0:
                self.y_velocity += 1
            else:
                self.y_velocity = 0
            img = "{} {}".format(self.start_image, self.frame)

            t = Transform(img, xanchor=0.5, yanchor=0.5, xzoom = self.facing )
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            if self.go_left or self.go_right or self.go_up or self.go_down or self.y < 0:
                renpy.redraw(self, 0)

            return rv

        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.go_left = -1
                    self.facing = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_d:
                    self.facing = 1
                    self.go_right = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                if ev.key == pygame.K_w:
                    # self.go_up = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_s:
                    # self.go_down = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.go_left = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_d:
                    self.go_right = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                if ev.key == pygame.K_w:
                    self.go_up = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_s:
                    self.go_down = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()




            return None

image bat:
    Crop((0,0,16,16), "bat-sheet")
    pause .2
    Crop((16,0,16,16), "bat-sheet")
    pause .2
    repeat


image hero 0 = Crop((0,0,32,32), "hero_sprite")
image hero 1 = Crop((32,0,32,32), "hero_sprite")
image hero 2 = Crop((64,0,32,32), "hero_sprite")
image hero 3 = Crop((92,0,32,32), "hero_sprite")
image hero 4 = Crop((128,0,32,32), "hero_sprite")
image hero 5 = Crop((160,0,32,32), "hero_sprite")


default moving = KeyRoll("hero")
default enemies = enemy_handler()

screen test(g = moving, e = enemies):

    timer .1 repeat True action Function(g.animate), Function(e.move, g)
    timer random.randint(1,3) repeat True action Function(e.tick)


    key "K_UP" action Function(g.attack, e.enemies)
    key "K_SPACE" action Function(g.jump)
    frame xysize 450,250 align .5,.5 background None:
        add "16x16" align .5,.5
        at zoom(4,True)
        add moving:
            align .5,.7331
        for i in e.enemies:
            if i.x < g.x:
                $ z = -1
            else:
                $ z = 1
            fixed fit_first True align .5,.753:
                at enemy_move(i.x, i.y, z)
                if i.alive:
                    add i.image at enemy_fade(1)

    vbox offset 100,100:
        text "Time: {}".format(e.time)
        text "Score: {}".format(e.score)
        # text str(g.x)
        # text str(g.y)
        # text str(len(e.enemies))
transform enemy_move(x, y, z = 1):
    xzoom z yoffset y
    ease .4 xoffset x 
transform enemy_fade(p):
    alpha 0
    pause p
    alpha 1

label hold_key_example:
    call screen test